//+------------------------------------------------------------------
//|
//+------------------------------------------------------------------
#property copyright "www.forex-tsd.com"
#property link      "www.forex-tsd.com"

#property indicator_chart_window
#property indicator_buffers 8

//
//
//
//
//

extern int    T3Period     = 14;
extern int    T3Price      = PRICE_CLOSE;
extern double T3Hot        = 0.7;
extern bool   T3Original   = true;
extern int    ShowLevel    = 3;
extern int    LinesWidth   = 1;
extern int    LinesWidthT3 = 2;
extern color  StartColor   = Lime;
extern color  EndColor     = PaleVioletRed;

double t3a[];
double t3b[];
double t3c[];
double t3d[];
double t3e[];
double t3f[];
double t3g[];
double t3h[];

//+------------------------------------------------------------------
//|                                                                  
//+------------------------------------------------------------------
//
//
//
//
//

int init()
{
   SetIndexBuffer(0,t3a);
   SetIndexBuffer(1,t3b);
   SetIndexBuffer(2,t3c);
   SetIndexBuffer(3,t3d);
   SetIndexBuffer(4,t3e);
   SetIndexBuffer(5,t3f);
   SetIndexBuffer(6,t3g);
   SetIndexBuffer(7,t3h);
      ShowLevel = MathMax(MathMin(ShowLevel,8),1);
   return(0);
}

//
//
//
//
//

int start()
{
   int i,limit,countedBars = IndicatorCounted();

   if (countedBars<0) return(-1);
   if (countedBars>0) countedBars--;
         limit = MathMin(Bars-countedBars,Bars-1);
         static bool colorsSet = false;
                if (!colorsSet)
                {
                     colorsSet=true;
                        for (int k=0; k<ShowLevel; k++)
                           if (k==2)
                                 SetIndexStyle(k,EMPTY,EMPTY,LinesWidthT3,gradientColor(k,ShowLevel,StartColor,EndColor));
                           else  SetIndexStyle(k,EMPTY,EMPTY,LinesWidth  ,gradientColor(k,ShowLevel,StartColor,EndColor));
                }            
   
   //
   //
   //
   //
   //
   
   for(i = limit; i >=0; i--)
   {
      t3a[i] = iGD(iMA(NULL,0,1,0,MODE_SMA,T3Price,i),T3Period,T3Hot,T3Original,i,0);
               if (ShowLevel>1) t3b[i] = iGD(t3a[i]  ,T3Period,T3Hot,T3Original,i,1);
               if (ShowLevel>2) t3c[i] = iGD(t3b[i]  ,T3Period,T3Hot,T3Original,i,2);
               if (ShowLevel>3) t3d[i] = iGD(t3c[i]  ,T3Period,T3Hot,T3Original,i,3);
               if (ShowLevel>4) t3e[i] = iGD(t3d[i]  ,T3Period,T3Hot,T3Original,i,4);
               if (ShowLevel>5) t3f[i] = iGD(t3e[i]  ,T3Period,T3Hot,T3Original,i,5);
               if (ShowLevel>6) t3g[i] = iGD(t3f[i]  ,T3Period,T3Hot,T3Original,i,6);
               if (ShowLevel>7) t3h[i] = iGD(t3g[i]  ,T3Period,T3Hot,T3Original,i,7);
   }      
	return(0);	
 }

//+------------------------------------------------------------------
//|
//+------------------------------------------------------------------
//
//
//
//
//

double workGD[][16];
#define _ema1 0
#define _ema2 1

double iGD(double price, double period, double hot, bool original, int i, int instanceNo=0)
{
   if (ArrayRange(workGD,0) != Bars) ArrayResize(workGD,Bars); instanceNo *= 2; i = Bars-i-1;
   if (original)
         double alpha = 2.0 / (1.0 + period);
   else         alpha = 2.0 / (2.0 + (period-1.0)/2.0);   
   
   //
   //
   //
   //
   //
         
      workGD[i][instanceNo+_ema1] = workGD[i-1][instanceNo+_ema1]+alpha*(price                      -workGD[i-1][instanceNo+_ema1]);
      workGD[i][instanceNo+_ema2] = workGD[i-1][instanceNo+_ema2]+alpha*(workGD[i][instanceNo+_ema1]-workGD[i-1][instanceNo+_ema2]);
   return((1.0+hot)*workGD[i][instanceNo+_ema1]-hot*workGD[i][instanceNo+_ema2]);
}

//+-------------------------------------------------------------------
//|                                                                  
//+-------------------------------------------------------------------
//
//
//
//
//

color gradientColor(int step, int totalSteps, color from, color to)
{
   color newBlue  = getColor(step,totalSteps,(from & 0XFF0000)>>16,(to & 0XFF0000)>>16)<<16;
   color newGreen = getColor(step,totalSteps,(from & 0X00FF00)>> 8,(to & 0X00FF00)>> 8) <<8;
   color newRed   = getColor(step,totalSteps,(from & 0X0000FF)    ,(to & 0X0000FF)    )    ;
   return(newBlue+newGreen+newRed);
}
color getColor(int stepNo, int totalSteps, color from, color to)
{
   double step = (from-to)/(totalSteps-1.0);
   return(MathRound(from-step*stepNo));
}


